* Machine code entensions to BASIC - String handling functions
* (i)   LET a$=LOWER$(b$) converts b$ into lower case
* (ii)  LET a$=UPPER$(b$) converts b$ into upper case
* (iii) LET a$=MIXED$(b$) converts b$ into mixed case

entry   move.w  $110,a0         ;bp.init vector
        lea     functs,a1       ;definition block address
        jsr     (a0)            ;linkage to BASIC
        rts                     ;back to BASIC

functs  dc.w    0               ;no procedures
        dc.w    0               ;end of procedure definitions
        dc.w    3               ;three new functions
        dc.w    up-*            ;definition for UPPER$
        dc.b    6,'UPPER$',0    ;name + pad character
        dc.w    lo-*            ;definition for LOWER$
        dc.b    6,'LOWER$',0    ;name + pad character
        dc.w    mi-*            ;definition for MIXED$
        dc.b    6,'MIXED$',0    ;name + pad character
        dc.w    0               ;end of definitions

* this is the definition for UPPER$

up      move.w  $116,a0         ;ca.gtstr vector
        jsr     (a0)            ;get parameters as strings
        tst.l   d0              ;error = 0 ?
        bne.s   quit            ;abort, error code in d0
        moveq   #-15,d0         ;err_bp, anticipate parameter error
        subq.w  #1,d3           ;just one parameter?
        beq.s   ok1             ;yes, no error
quit    rts                     ;quit with the error code already in d0
ok1     move.l  a1,$58(a6)      ;RI stack ptr into BV.RIP
        move.w  0(a6,a1.l),d1   ;length of string into d1
        tst.w   d1              ;check for empty string
        beq.s   zeropt          ;no need to modify, null string
        ext.l   d1              ;extend to long word
        movea.l a1,a2           ;copy of string start
        addq.l  #2,a2           ;skip string length word
        subq.l  #1,d1           ;prepare for DBF
loop1   move.b  0(a6,a2.l),d2   ;get this character
        cmp.b   #97,d2          ;< "a" ?
        blt.s   nxtlp1          ;yes, no need to modify
        cmp.b   #122,d2         ;> "z" ?
        bgt.s   nxtlp1          ;yes, no need to modify
        subi.b  #32,d2          ;mask out lower case bit
        move.b  d2,0(a6,a2.l)   ;put it back in string
nxtlp1  addq.l  #1,a2           ;point to next character
        dbf     d1,loop1        ;next character, if any
zeropt  moveq   #1,d4           ;string to be returned
        clr.l   d0              ;no error
        rts                     ;back to BASIC

* this is the definition for LOWER$

lo      move.w  $116,a0         ;ca.gtstr
        jsr     (a0)            ;get strings parameters
        tst.l   d0              ;error=0?
        bne.s   quit            ;abort, error code in d0
        moveq   #-15,d0         ;anticipate err_bp
        subq.w  #1,d3           ;just one parameter?
        bne.s   quit            ;no, quit with error report d0
ok2     move.l  a1,$58(a6)      ;ri.ptr into bv.rip
        move.w  0(a6,a1.l),d1   ;length of string into d1
        tst.w   d1              ;check for empty string
        beq.s   zeropt          ;null string, no need to modify
        ext.l   d1              ;extend to long word
        movea.l a1,a2           ;copy of string start
        addq.l  #2,a2           ;skip length word
        subq.l  #1,d1           ;prepare for DBF
loop2   move.b  0(a6,a2.l),d2   ;get this character
        cmp.b   #65,d2          ;<"A"?
        blt.s   nxtlp2          ;yes, no need to modify
        cmp.b   #90,d2          ;>"Z"?
        bgt.s   nxtlp2          ;yes, no need to modify
        addi.b  #32,d2          ;set lower case bit
        move.b  d2,0(a6,a2.l)   ;put character back in string
nxtlp2  addq.l  #1,a2           ;point to next character
        dbf     d1,loop2        ;next character, if any
        bra.s   zeropt          ;return converted string to BASIC

* this is the definition for MIXED$
mi      move.w  $116,a0         ;ca.gtstr
        jsr     (a0)            ;get strings parameters
        tst.l   d0              ;error=0?
        bne     quit            ;abort, error code in d0
        moveq   #-15,d0         ;anticipate err_bp
        subq.w  #1,d3           ;just one parameter?
        bne     quit            ;no, quit with error report d0
ok3     move.l  a1,$58(a6)      ;ri.ptr into bv.rip
        move.w  0(a6,a1.l),d1   ;length of string into d1
        tst.w   d1              ;check for empty string
        beq.s   zeropt          ;null string, no need to modify
        ext.l   d1              ;extend to long word
        movea.l a1,a2           ;copy of string start
        addq.l  #2,a2           ;skip length word
        subq.l  #1,d1           ;prepare for DBF

* convert first character ONLY to upper case
        move.b  0(a6,a2.l),d2   ;get first character
        cmp.b   #97,d2          ;<"a"?
        blt.s   zz              ;yes, no need to modify
        cmp.b   #122,d2         ;>"z"?
        bgt.s   zz              ;yes, no need to modify
        subi.b  #32,d2          ;mask out lower case bit
        move.b  d2,0(a6,a2.l)   ;replace character in string
zz      addq.l  #1,a2           ;next character in string
        tst.w   d1              ;1 character length?
        beq     zeropt          ;yes, end of string

* convert remainder of string to mixed case
        subq.l  #1,d1           ;prepare for DBF loop again

loop3   move.b  0(a6,a2.l),d2   ;fetch character byte
        cmp.b   #65,d2          ;<"A"?
        blt.s   nxtlp3          ;yes, no need to modify
        cmp.b   #90,d2          ;>"Z"?
        bgt.s   nxtlp3          ;yes, no need to modify
        addi.b  #32,d2          ;set lower case bit
        move.b  d2,0(a6,a2.l)   ;put character back into string
nxtlp3  addq.l  #1,a2           ;point to next character
        dbf     d1,loop3        ;next character if any
        bra     zeropt          ;return converted string to BASIC
