* function to reverse characters of a string
* LET s$ = REVERSE(t$)
          lea       proc_def,a1         ;definition block
          move.w    $110,a0             ;bp.init
          jsr       (a0)                ;link to basic
          rts                           ;return to basic

proc_def  dc.w      0                   ;no procedures
          dc.w      0                   ;end of procedures
          dc.w      1                   ;1 function
          dc.w      reverse-*           ;where is it?
          dc.b      7,'REVERSE'         ;name?
          dc.w      0                   ;end of functions

reverse   move.w    $116,a0             ;ca.gtstr
          jsr       (a0)                ;fetch string parameter
          bne.s     quit                ;oops
          subq.w    #1,d3               ;just one parameter?
          beq.s     ok1                 ;yes, no error
          moveq     #-15,d0             ;err_bp
quit      rts                           ;quit with error code in d0
ok1       move.l    a1,$58(a6)          ;RI stack pointer into bv_rip
          move.w    0(a6,a1.l),d1       ;length of string
          cmpi.w    #2,d1               ;check for empty string
          blt.s     zeropt       ;no need to modify null or 1 character
          ext.l     d1
* we have a non-zero length string on the stack, so prepare to reverse
* by setting up pointers to the beginning and end of the string which
* will move together, remembering that there is no need to reverse the
* middle character in an odd length string
          move.l    a1,a2               ;pointer to start of string
          add.l     #2,a2               ;skip length word
          move.l    a2,a3               ;pointer to end of string
          add.l     d1,a3               ;this takes it one past the end
          subq.l    #1,a3               ;now it points to end of string
          lsr.l     #1,d1               ;length div 2
          subq.l    #1,d1               ;prepare to dbf
rev_loop  move.b    0(a6,a2.l),d0       ;fetch byte from start of str
          move.b    0(a6,a3.l),0(a6,a2.l) ;swap a character
          move.b    d0,0(a6,a3.l)       ;swap the other half
          addq.l    #1,a2               ;point to next character
          subq.l    #1,a3               ;ditto in opposite direction
          dbf       d1,rev_loop         ;any more?
zeropt    moveq     #1,d4               ;string to be returned
          clr.l     d0                  ;no error
          rts
